//+------------------------------------------------------------------+
//|                                                    FXGuy2000.mq4 |
//|                                      Copyright  2005, FXGuy2000 |
//|                                 http://www.truth-about-forex.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, FXGuy2000"
#property link      "http://www.truth-about-forex.com"
      
   /*user settings*/
extern   double lots=0.1;
extern   int Slippage   = 3;
extern   int Magic      = 8888;
extern   int emafast=5;
extern   int emaslow=40;
extern   double Stoploss   = 0;
extern   double TakeProfit = 0;
extern   double TrailStop  = 0;
extern   int flagSendEmail=0; //1 for true, 0 for false
extern   int waitingtime=0; 
   /*end of user settings*/  

   int cnt, ticket, total, digit;
   double flag=0;  // buy/sell flag
   double flag2=0; //flag to see if program has been run at least once
   double flagtimestored=0; //flag for time already set and stored
   double flagpending=0; //pending flag to see if it passes time
   double BotTradedThisSession=0;
   double var1=0;
   double var2=0;
   double storedtime=0;
   string mytext, mailsubject; 
   double SellStop = 0, SellProfit = 0, BuyStop = 0, BuyProfit=0;
   
int init(){return(0);}
int deinit(){return(0);}
int start()
  {
   digit  = MarketInfo(Symbol(),MODE_DIGITS);
   if (TakeProfit > 0) 
   { SellProfit = Bid-TakeProfit*Point; BuyProfit = Ask + TakeProfit*Point;}
   else if (TakeProfit == 0) {SellProfit = 0; BuyProfit = 0;} 
   
   if (Stoploss > 0) 
   { SellStop = Ask + Stoploss*Point; BuyStop = Bid - Stoploss*Point;}
   else if (Stoploss == 0) {SellStop = 0; BuyStop = 0;} 
   
   
   var1=iMA(NULL,0,emafast,0,MODE_EMA,PRICE_CLOSE,1);
   var2=iMA(NULL,0,emaslow,0,MODE_EMA,PRICE_CLOSE,1);
   total=OrdersTotal();
   
   // ------------ this section checks to see if there is a bad trade going on when the script is started! ----
   
   if (TrailStop > 0) TrailStops();
   
   if(total==1 && flag2==0){
      for(cnt=0;cnt<1;cnt++){ 
            if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)==true)
            {
            if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber()==Magic ){
                if(var1>var2){
		          OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); 
		          //flag2=1;
		          }}
		      if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber()==Magic ){
                if(var1<var2){
		          OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); 
		          //flag2=1;
		          }}
		       }}
		    }
   
   // --------------------------------------------------------------------------------		      
   
   mytext=StringConcatenate("EMA",emafast," - ",var1," v.s EMA",emaslow," - ",var2," for period: ", Period()," Pending: ", flagpending," TradedThisSession?: ", BotTradedThisSession," Total Trades: ", total);	   
   Comment(mytext); //HIDE COMMENTS WHEN READY
   
   if(flag2==1 && flagtimestored==0){ //this means we have been in the program at least once and time hasn't been stored
      if(var1>var2 && flag==2)
		{
	      mytext=StringConcatenate(Period()," TF ",Symbol()," Standby for LONG @ ", Ask);	   
		   Alert(mytext);
		   flagpending=1;
		   storedtime=CurTime();
		   flagtimestored=1; //time is stored
        }
      if(var1<var2 && flag==1)
      {
         mytext=StringConcatenate(Period()," TF ",Symbol()," Standby for SHORT @ ", Bid);
         Alert(mytext);
         flagpending=2;
         storedtime=CurTime();
         flagtimestored=1; //time is stored
      }
     }
   
   if(flag2==0){ //this means we have not been in the program and we should only be in this loop once
    if(var1>var2)
		{flag=1;} //set initial buy flag
    if(var1<var2)
      {flag=2;} //set initial sell flag      
      flag2=1;} //set to show we've been in the program at least once
   
   /****here we test if time has been stored ***/
   
   if(flagtimestored==1){
      if((flagpending==1 && var1<var2) || (flagpending==2 && var1>var2)){ //reset time stored flag b/c we got an opposite signal
         flagtimestored=0;
         flagpending=0;
         if(var1>var2)
	  	      {flag=1;} //set trigger flag 
         if(var1<var2)
            {flag=2;} //set trigger flag     
         }
        }
   
   // program in once and time has been stored
     
     if(flag2==1 && flagtimestored==1){ //this means we have been in the program at least once and time has been stored
      if(CurTime() - storedtime > waitingtime) //this makes sure that at least WAITING TIME has elapsed since the pending flag was set
		{
		//---------- LONG AREA ----------------------//
		   if(flagpending==1){
		   if(total>1){Alert("Error ... There are more than 1 trade open now!");}
		   if(total>0 && total<2){
		   //close and open new order
		    for(cnt=0;cnt<1;cnt++){
            if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)==true)
            {
            if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber()==Magic ){
		          OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close bad SHORT position
		          Alert(GetLastError());
		          }
		      if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber()==Magic ){
		          Alert("Warning: LONG trade already present");
		          flag=1;
		          }
		       }
		       total=OrdersTotal();
		      }
		    if(total==0 && GetLastError()==0) //it will buy another LONG here ...
		    {
		    ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,Slippage,
		                     NormalizeDouble(BuyStop,digit),
		                     NormalizeDouble(BuyProfit,digit),
		                     "AutoLong",Magic,0,Green);
          if(ticket<1)
            {
               Print("OrderSend failed with error #",GetLastError());
               return(0);
            }
          else
            {
            flag=1;
            flagtimestored=0;
            flagpending=0;
            if(flagSendEmail==1){
            mailsubject=StringConcatenate("MT4: ",Symbol()," LONG @ ", Ask);
            SendMail(mailsubject,"");}
            BotTradedThisSession=1;
            }
          }
         }
		   else{
	      mytext=StringConcatenate(Period(), " Time passed! No trades at present. LONG @ ", Ask);	   
		   Alert(mytext);
		   flag=1;
		   flagtimestored=0; 
		   ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,Slippage,
		                    NormalizeDouble(BuyStop,digit),
		                    NormalizeDouble(BuyProfit,digit),
		                    "AutoLong",Magic,0,Green);
         if(ticket<1)
            {
               Print("OrderSend failed with error #",GetLastError());
               return(0);
            }else{
          flag=1;
          flagtimestored=0;
          flagpending=0;
          if(flagSendEmail==1){
          mailsubject=StringConcatenate("MT4: ",Symbol()," LONG @ ", Ask);
		    SendMail(mailsubject,"");}
		    BotTradedThisSession=1;
		    }}}
        //-------- END LONG & START SHORT ------------------//
         if(flagpending==2){
         if(total>1){Alert("Error ... There are more than 1 trade open now!");}
         if(total>0 && total<2){
         for(cnt=0;cnt<1;cnt++){
            if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)==true)
            {
            if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber()==Magic ){
		          OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close bad LONG position
		          Alert(GetLastError());
		          }
		      if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber()==Magic ){
		          Alert("Warning: SHORT trade already present");
		          flag=2;
		          }
		      }
		      total=OrdersTotal();
		     }
		     if(total==0 && GetLastError()==0)
		     {
           ticket=OrderSend(Symbol(),OP_SELL,lots,Bid,Slippage,
                            NormalizeDouble(SellStop,digit),
		                      NormalizeDouble(SellProfit,digit),
		                      "AutoShort",Magic,0,Green);
           if(ticket<1)
            {
               Print("OrderSend failed with error #",GetLastError());
               return(0);
            }
            else
            {
            flag=2;
            flagtimestored=0;
            flagpending=0;
            if(flagSendEmail==1){
            mailsubject=StringConcatenate("MT4: ",Symbol()," SHORT @ ", Bid);
            SendMail(mailsubject,"");}
		      BotTradedThisSession=1;
            }
           }
          }
         else{
	      mytext=StringConcatenate(Period()," Time passed! No trades at present. SHORT @ ", Bid);	   
		   Alert(mytext);
		   flag=2;
		   flagtimestored=0;
		   ticket=OrderSend(Symbol(),OP_SELL,lots,Bid,Slippage,
		                    NormalizeDouble(SellStop,digit),
		                    NormalizeDouble(BuyProfit,digit),
		                    "AutoShort",Magic,0,Green);
         if(ticket<1)
               {
                Print("OrderSend failed with error #",GetLastError());
                 return(0);
               }else{
          flag=2;
          flagtimestored=0;
          flagpending=0;
          if(flagSendEmail==1){
          mailsubject=StringConcatenate("MT4: ",Symbol()," SHORT @ ", Bid);
		    SendMail(mailsubject,"");}
		    BotTradedThisSession=1;
		    }}}
        //---------- END SHORT -------------------- //
     }}   
     return(0);
  }
  
void TrailStops()
{        
    //int total=OrdersTotal();
    for (cnt=0;cnt<total;cnt++)
    { 
     OrderSelect(cnt, SELECT_BY_POS);   
     int mode=OrderType();    
        if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic ) 
        {
            if ( mode==OP_BUY && Bid - TrailStop*Point > OrderStopLoss() )
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),
                        NormalizeDouble(Bid - TrailStop*Point,digit),
                        OrderTakeProfit(),0,LightGreen);
			   return(0);
            }
           if ( mode==OP_SELL && Ask + TrailStop*Point < OrderStopLoss())
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),
                        NormalizeDouble(Ask + TrailStop*Point,digit),
                        OrderTakeProfit(),0,Yellow);	    
            return(0);
            }    
        }
    }   
}   